#include <iostream>

using namespace std;

int min(int x, int y)
{
	if(x > y)
		return y;
	return x;
}

int main()
{
	int n, q;
	cin >> n >> q;
	int dani[n];
	int plazme[n];
	int pitanja[q];
	
	for(int i = 0; i < n; i++)
	{
		cin >> dani[i] >> plazme[i];
	}
	for(int i = 0; i < q; i++)
	{
		cin >> pitanja[i];
	}
	
	for(int i = 0; i < q; i++)
	{
		int r = 0;
		for(int j = 0; j < n; j++)
		{
			if(dani[j] > pitanja[i])
			{
				cout << r << endl;
				break;
			}
			r += min(plazme[j], pitanja[i] - dani[j] + 1);
		}
		cout << r << endl;
	}
}